<?php

namespace Lc\CaracoleBundle\Container\Credit;

use Lc\CaracoleBundle\Builder\Credit\CreditHistoryBuilder;
use Lc\CaracoleBundle\Factory\Credit\CreditHistoryFactory;
use Lc\CaracoleBundle\Repository\Credit\CreditHistoryRepositoryQuery;
use Lc\CaracoleBundle\Repository\Credit\CreditHistoryStore;

class CreditHistoryContainer
{
    protected CreditHistoryFactory $factory;
    protected CreditHistoryRepositoryQuery $repositoryQuery;
    protected CreditHistoryStore $store;
    protected CreditHistoryBuilder $builder;

    public function __construct(
            CreditHistoryFactory $factory,
            CreditHistoryRepositoryQuery $repositoryQuery,
            CreditHistoryStore $store,
            CreditHistoryBuilder $builder
    ) {
        $this->factory = $factory;
        $this->repositoryQuery = $repositoryQuery;
        $this->store = $store;
        $this->builder = $builder;
    }

    public function getFactory(): CreditHistoryFactory
    {
        return $this->factory;
    }

    public function getRepositoryQuery(): CreditHistoryRepositoryQuery
    {
        return $this->repositoryQuery;
    }

    public function getStore(): CreditHistoryStore
    {
        return $this->store;
    }

    public function getBuilder(): CreditHistoryBuilder
    {
        return $this->builder;
    }
}
